set echo off
set feedback on
set verify on
set termout off
set pause off
set echo on
disconnect
connect scott/tiger@ora816d
DROP TABLE GT_PRICE_P;
DROP TABLE GT_PRICE_D;
clear screen
spool 4
set termout on
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_P
(
        PRODUCT_ID              NUMBER (6),
        LIST_PRICE              NUMBER (8,2),
        MIN_PRICE               NUMBER (8,2),
        START_DATE              DATE,
        END_DATE                DATE
)
ON COMMIT PRESERVE ROWS
;
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_D
(
        PRODUCT_ID              NUMBER (6),
        LIST_PRICE              NUMBER (8,2),
        MIN_PRICE               NUMBER (8,2),
        START_DATE              DATE,
        END_DATE                DATE
)
ON COMMIT DELETE ROWS
;
pause
clear screen
insert into gt_price_p select * from price;
insert into gt_price_d select * from price;
select	count(*) from	   price;
select	count(*) from	gt_price_d;
select	count(*) from	gt_price_p;
analyze table    PRICE   compute statistics;
analyze table GT_PRICE_P compute statistics;
analyze table GT_PRICE_D compute statistics;
--populate tables and analyze
pause
clear screen
select table_name, num_rows, blocks, empty_blocks, avg_space, chain_cnt, avg_row_len, 
avg_space_freelist_blocks, num_freelist_blocks, last_analyzed
from user_tables
where table_name IN('GT_PRICE_D','GT_PRICE_P','PRICE')
;
--no statistics on GT tables
pause 
clear screen
select	count(*) from	gt_price_d;
select	count(*) from	gt_price_p;
--analyze implies commit
pause
execute sys.dbms_stats.drop_stat_table('SCOTT', stattab => 'GTSTATS');
execute sys.dbms_stats.create_stat_table('SCOTT', stattab => 'GTSTATS');
clear screen
execute sys.dbms_stats.gather_table_stats('SCOTT', 'GT_ITEM', cascade => TRUE, stattab => 'GTSTATS');
rem cannot gather stats on a GT table!
--go back to presentation
spool off
