set echo off
set feedback on
set verify on
set termout off
set pause off
set echo on
disconnect
connect scott/tiger@ora816d
DROP TABLE GT_PRICE_P;
clear screen
spool 5
set termout on
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_P
(
        PRODUCT_ID              NUMBER (6),
        LIST_PRICE              NUMBER (8,2),
        MIN_PRICE               NUMBER (8,2),
        START_DATE              DATE,
        END_DATE                DATE
)
ON COMMIT PRESERVE ROWS
;
insert into gt_price_p select * from price;
select	count(*) from	gt_price_p;
commit;
drop table gt_price_p;
--can drop table, no other session, transaction ended
--go back to presentation
pause
disconnect
connect scott/tiger@ora816d
DROP TABLE GT_PRICE_P;
DROP TABLE GT_PRICE_D;
clear screen
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_P 
ON COMMIT PRESERVE ROWS
AS SELECT * FROM price
;
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_D
ON COMMIT DELETE ROWS
AS SELECT * FROM price
;
--I can use CTAS syntax
pause
CREATE UNIQUE INDEX I_GT_PRICE_D ON GT_PRICE_D (PRODUCT_ID, START_DATE);
CREATE UNIQUE INDEX I_GT_PRICE_P ON GT_PRICE_P (PRODUCT_ID, START_DATE);
--but I run into trouble with indexes
pause
select	count(*) from	gt_price_p;
select	count(*) from	gt_price_d;
--If I preserved the rows I can't build an index
--If I didn't then the implicit commit removed the rows
pause
disconnect
connect scott/tiger@ora816d
DROP TABLE GT_PRICE_P;
DROP TABLE GT_PRICE_D;
clear screen
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_P 
(       PRODUCT_ID
,       LIST_PRICE
,       MIN_PRICE
,       START_DATE
,       END_DATE
,	CONSTRAINT i_gt_price_p PRIMARY KEY(PRODUCT_ID, START_DATE) 
)
ON COMMIT PRESERVE ROWS
AS SELECT * FROM price
;
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_D
(       PRODUCT_ID
,       LIST_PRICE
,       MIN_PRICE
,       START_DATE
,       END_DATE
,	CONSTRAINT i_gt_price_d PRIMARY KEY(PRODUCT_ID, START_DATE) 
)
ON COMMIT DELETE ROWS
AS SELECT * FROM price
;
--CTAS+unique key
pause
select	count(*) from	gt_price_p;
select	count(*) from	gt_price_d;
--as expected I only have rows in ON PRESERVE table
pause
--I'll insert the same rows as CTAS into each table
insert into gt_price_p select * from price;
insert into gt_price_d select * from price;
--spot anything wrong?
pause
insert into gt_price_p select * from price;
insert into gt_price_d select * from price;
--well there are constraints
pause
select	count(*) from	gt_price_p;
select	count(*) from	gt_price_d;
--I have duplicate rows and unique constraint (on 8.1.7.4 on NT4).
--but ONLY if I create the constraint in the CTAS statement and put rows into the table
--1 more time
pause
disconnect
connect scott/tiger@ora816d
DROP TABLE GT_PRICE_P;
clear screen
CREATE GLOBAL TEMPORARY TABLE GT_PRICE_P 
(       PRODUCT_ID
,       LIST_PRICE
,       MIN_PRICE
,       START_DATE
,       END_DATE
,	CONSTRAINT i_gt_price_p PRIMARY KEY(PRODUCT_ID, START_DATE) 
)
ON COMMIT PRESERVE ROWS
AS SELECT * FROM price
;
select	count(*) from	gt_price_p;
select * from v$sort_usage;
--my index didn't create
pause
insert into gt_price_p select * from price;
select	count(*) from	gt_price_p;
select * from v$sort_usage;
--and there it is
spool off
